/*
 *	    ____  ____  _____   ____________
 *	   / __ / __ /  _/ | / /_  __/ __
 *	  / /_/ / /_/ // //  |/ / / / / /_/ /
 *	 / ____/ _, _// // /|  / / / / _, _/
 *	/_/   /_/ |_/___/_/ |_/ /_/ /_/ |_|
 *
 */

var fs 		= require('fs');
var	path	= require('path');

module.exports = {

	// static
	PROJECT_FILE: 'project.json',
	PROJECT_DEFAULT:
	{
		"name": "",
		"version": "1.0.0",
		"identifier": "",
	    "properties":
	    {
	    	"assets": false,
	        "plugin": false,
	        "config": false
	    },
	    "dependencies":
	    {
	    	"formideViewer": "latest"
	    }
	},

	init: function( Formide )
	{
		this.Formide = Formide;
	},

	// functions
	load: function( identifier )
	{
		this.config = this.Formide.PROJECT_PATH + '/' + identifier + '/' + this.PROJECT_FILE;
		if( fs.existsSync( this.config ) )
		{
			try
			{
				this.data = JSON.parse( fs.readFileSync( this.config ) );
				return this;
			}
			catch( ex )
			{
				throw new Error( 'There was an error loading your formide.project file: ' + ex.message );
			}
		}
	},

	create: function( name )
	{
		this.config = this.PROJECT_DEFAULT;
		return this;
	},

	getConfig: function()
	{
		return this.data;
	},

	saveConfig: function( json )
	{
		this.data = json;
	}
};